'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _osx = require('./styles/osx.10.11');

var _osx2 = _interopRequireDefault(_osx);

var _desktopComponent = require('../../desktop-component');

var _desktopComponent2 = _interopRequireDefault(_desktopComponent);

var _color = require('../../color');

var _text = require('../../text/text.osx/text');

var _text2 = _interopRequireDefault(_text);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Box = (_dec = (0, _desktopComponent2.default)(_desktopComponent.Dimension, _desktopComponent.Margin, _desktopComponent.Padding, _desktopComponent.Alignment, _desktopComponent.Hidden, _desktopComponent.Background), _dec(_class = (_temp = _class2 = function (_Component) {
  _inherits(Box, _Component);

  function Box() {
    _classCallCheck(this, Box);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Box).apply(this, arguments));
  }

  _createClass(Box, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var style = _props.style;
      var background = _props.background;
      var label = _props.label;

      var props = _objectWithoutProperties(_props, ['children', 'style', 'background', 'label']);

      var hasSegmentedControls = false;

      var componentStyle = _extends({}, _osx2.default.box, style);
      if (hasSegmentedControls) {
        componentStyle = _extends({}, _osx2.default.segmentedControls);
      }

      if (background) {
        background = (0, _color.convertColor)(background);
        componentStyle = _extends({}, componentStyle, {
          backgroundColor: background,
          borderTopColor: (0, _color.darkenColor)(background, .3),
          borderLeftColor: (0, _color.darkenColor)(background, .24),
          borderRightColor: (0, _color.darkenColor)(background, .24),
          borderBottomColor: (0, _color.darkenColor)(background, .19)
        });
      }

      if (label) {
        return _react2.default.createElement(
          'div',
          props,
          _react2.default.createElement(
            _text2.default,
            { margin: '0 0 1px 7px', size: 11 },
            label
          ),
          _react2.default.createElement(
            'div',
            {
              ref: 'box',
              style: componentStyle
            },
            children
          )
        );
      }
      return _react2.default.createElement(
        'div',
        _extends({
          ref: 'box',
          style: componentStyle
        }, props),
        children
      );
    }
  }]);

  return Box;
}(_react.Component), _class2.propTypes = {
  label: _react.PropTypes.string
}, _class2.styleRefs = {
  padding: 'box',
  dimension: 'box'
}, _temp)) || _class);
exports.default = Box;