'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _desktopComponent = require('../../desktop-component');

var _desktopComponent2 = _interopRequireDefault(_desktopComponent);

var _radium = require('radium');

var _osx = require('./styles/osx.10.11');

var _osx2 = _interopRequireDefault(_osx);

var _checkmark = require('./checkmark');

var _checkmark2 = _interopRequireDefault(_checkmark);

var _text = require('../../text/text.osx/text');

var _text2 = _interopRequireDefault(_text);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Checkbox = (_dec = (0, _desktopComponent2.default)(_desktopComponent.Hidden), _dec(_class = (_temp = _class2 = function (_Component) {
  _inherits(Checkbox, _Component);

  function Checkbox(props) {
    _classCallCheck(this, Checkbox);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Checkbox).call(this));

    _this.onChange = function (event) {
      _this.setState({ checked: event.target.checked });
      if (_this.props.onChange) {
        _this.props.onChange(event);
      }
    };

    _this.state = {
      checked: props.defaultChecked === true
    };
    return _this;
  }

  _createClass(Checkbox, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var style = _props.style;
      var label = _props.label;

      var props = _objectWithoutProperties(_props, ['style', 'label']);

      var componentStyle = _extends({}, _osx2.default.checkbox, style);
      var labelStyle = _osx2.default.label;
      var shadowColor = '#0050a5';

      if (this.state.checked) {
        componentStyle = _extends({}, componentStyle, _osx2.default['checkbox:checked']);
      }

      if ((0, _radium.getState)(this.state, null, ':active')) {
        if (this.state.checked) {
          componentStyle = _extends({}, componentStyle, _osx2.default['checkbox:checked:active']);
          shadowColor = '#001d99';
        } else {
          componentStyle = _extends({}, componentStyle, _osx2.default['checkbox:active']);
        }
      }

      return _react2.default.createElement(
        'label',
        { style: labelStyle },
        _react2.default.createElement('input', _extends({
          ref: 'element',
          type: 'checkbox'
        }, props, {
          style: componentStyle,
          onChange: this.onChange
        })),
        _react2.default.createElement(_checkmark2.default, { show: this.state.checked, shadowColor: shadowColor }),
        _react2.default.createElement(
          _text2.default,
          { style: { display: 'inline' } },
          label
        )
      );
    }
  }]);

  return Checkbox;
}(_react.Component), _class2.propTypes = {
  label: _react.PropTypes.string,
  onChange: _react.PropTypes.func
}, _temp)) || _class);
exports.default = Checkbox;