'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _desktopComponent = require('../../desktop-component');

var _desktopComponent2 = _interopRequireDefault(_desktopComponent);

var _radium = require('radium');

var _windows = require('./styles/windows.10');

var _windows2 = _interopRequireDefault(_windows);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Checkbox = (_dec = (0, _desktopComponent2.default)(_desktopComponent.Hidden), _dec(_class = (_temp = _class2 = function (_Component) {
  _inherits(Checkbox, _Component);

  function Checkbox(props) {
    _classCallCheck(this, Checkbox);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Checkbox).call(this));

    _this.onChange = function (event) {
      _this.setState({ checked: event.target.checked });
      if (_this.props.onChange) {
        _this.props.onChange(event);
      }
    };

    _this.state = {
      checked: props.defaultChecked === true
    };
    return _this;
  }

  _createClass(Checkbox, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var style = _props.style;
      var label = _props.label;
      var color = _props.color;

      var props = _objectWithoutProperties(_props, ['style', 'label', 'color']);

      var componentStyle = _extends({}, _windows2.default.checkbox, style);
      var checkedStyle = { display: 'none' };
      var labelStyle = _windows2.default.label;

      if (this.state.theme === 'dark') {
        componentStyle = _extends({}, componentStyle, _windows2.default.checkboxDark);
        labelStyle = _extends({}, labelStyle, _windows2.default.labelDark);
      }

      if (this.state.checked) {
        checkedStyle = _windows2.default.svg;
        componentStyle = _extends({}, componentStyle, this.state.theme === 'dark' ? _windows2.default['checkboxDark:checked'] : _windows2.default['checkbox:checked']);

        if (color && color !== true) {
          componentStyle = _extends({}, componentStyle, {
            backgroundColor: color,
            borderColor: color
          });
        } else {
          componentStyle = _extends({}, componentStyle, {
            backgroundColor: this.state.color,
            borderColor: this.state.color
          });
        }
      }

      if ((0, _radium.getState)(this.state, null, ':active')) {
        componentStyle = _extends({}, componentStyle, this.state.theme === 'dark' ? _windows2.default['checkboxDark:active'] : _windows2.default['checkbox:active']);
      } else if ((0, _radium.getState)(this.state, null, ':hover')) {
        componentStyle = _extends({}, componentStyle, this.state.theme === 'dark' ? _windows2.default['checkboxDark:hover'] : _windows2.default['checkbox:hover']);
      }

      return _react2.default.createElement(
        'label',
        { style: labelStyle },
        _react2.default.createElement('input', _extends({
          ref: 'element',
          type: 'checkbox'
        }, props, {
          style: componentStyle,
          checked: this.state.checked,
          onChange: this.onChange
        })),
        _react2.default.createElement(
          'svg',
          { x: '0px', y: '0px', viewBox: '0 0 6.4 6.4', style: checkedStyle },
          _react2.default.createElement('polygon', { fill: '#fff', points: '0,3.3 2.2,5.5 6.4,1.23 6.1,0.9 2.2,4.8 0.3,2.9 ' })
        ),
        label
      );
    }
  }]);

  return Checkbox;
}(_react.Component), _class2.propTypes = {
  color: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.bool]),
  label: _react.PropTypes.string,
  onChange: _react.PropTypes.func
}, _temp)) || _class);
exports.default = Checkbox;