'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.set = set;
exports.get = get;
var _os = void 0;

function set(value) {
  _os = value;
}

function get() {
  if (_os) {
    return _os;
  }

  // explicitly set these to avoid issues
  var window = window || null;
  var navigator = navigator || null;
  var process = process || window && window.process || null;

  // via node
  if (process && process.platform) {
    if (process.platform === 'darwin') {
      return 'osx';
    }
    if (process.platform.includes('win')) {
      return 'win';
    }
  }

  // via user agent
  if (navigator && navigator.userAgent) {
    if (navigator.userAgent.includes('Macintosh')) {
      return 'osx';
    }
    if (navigator.userAgent.includes('Windows')) {
      return 'win';
    }
  }

  // default to osx
  return 'osx';
}