'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _desktopComponent = require('../../../desktop-component');

var _desktopComponent2 = _interopRequireDefault(_desktopComponent);

var _title = require('./title');

var _title2 = _interopRequireDefault(_title);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  content: {
    display: 'flex',
    flex: '1',
    flexDirection: 'column'
  },

  component: {
    display: 'flex',
    flex: '1',
    flexDirection: 'column'
  }
};

var Content = (0, _desktopComponent2.default)(_class = (_temp = _class2 = function (_Component) {
  _inherits(Content, _Component);

  function Content(props, context, updater) {
    _classCallCheck(this, Content);

    var parentTheme = props.parentTheme;
    var selected = props.selected;

    var properties = _objectWithoutProperties(props, ['parentTheme', 'selected']);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Content).call(this, properties, context, updater));

    _this.state = {
      selected: selected,
      parentTheme: parentTheme
    };
    return _this;
  }

  _createClass(Content, [{
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps, nextState) {
      if (this.refs.title) {
        this.refs.title.setState({
          selected: nextState.selected,
          parentTheme: nextState.parentTheme
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var parentRequestTheme = _props.parentRequestTheme;
      var style = _props.style;
      var title = _props.title;
      var icon = _props.icon;

      var props = _objectWithoutProperties(_props, ['children', 'parentRequestTheme', 'style', 'title', 'icon']);

      var componentStyle = _extends({}, styles.component, {
        margin: this.props.margin,
        padding: this.props.padding
      }, style);

      if (this.state.background) {
        componentStyle.backgroundColor = this.state.background;
      }

      return _react2.default.createElement(
        'div',
        _extends({ style: styles.content }, props),
        _react2.default.createElement(
          _title2.default,
          {
            ref: 'title',
            selected: this.state.selected,
            parentTheme: this.state.parentTheme,
            previousTitle: this.item.splitView.currentTitle
          },
          title
        ),
        _react2.default.createElement(
          'div',
          { style: componentStyle },
          children
        )
      );
    }
  }, {
    key: 'item',
    get: function get() {
      return this.context.parent;
    }
  }]);

  return Content;
}(_react.Component), _class2.propTypes = {
  title: _react.PropTypes.string,
  parentTheme: _react.PropTypes.string,
  margin: _react.PropTypes.string,
  padding: _react.PropTypes.string
}, _temp)) || _class;

exports.default = Content;