'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _desktopComponent = require('../../../desktop-component');

var _desktopComponent2 = _interopRequireDefault(_desktopComponent);

var _radium = require('radium');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var appear = (0, _radium.keyframes)({
  '0%': {
    opacity: 0
  },
  '29%': {
    opacity: 0,
    transform: 'translateY(9px)'
  },
  '30%': {
    opacity: .35,
    transform: 'translateY(9px)'
  },
  '100%': {
    opacity: 1,
    transform: 'translateY(0)'
  }
}, 'Title');

var fadeOut = (0, _radium.keyframes)({
  '0%': {
    opacity: 1
  },
  '100%': {
    opacity: 0
  }
}, 'span');

var styles = {
  title: {
    position: 'relative',
    color: '#000000',
    height: '48px',
    display: 'flex',
    alignItems: 'center',
    fontFamily: '"Segoe UI", Frutiger, "Frutiger Linotype", "Dejavu Sans", "Helvetica Neue", Arial, sans-serif',
    fontSize: '15px',
    textTransform: 'uppercase',
    padding: '0 24px',
    overflow: 'hidden'
  },

  titleDark: {
    color: '#ffffff'
  },

  fadeSpanStyle: {
    position: 'absolute',
    top: '0',
    left: '0',
    animation: fadeOut + ' 100ms forwards'
  },

  titleAnimation: {
    animation: appear + ' 300ms'
  }
};

var Title = (0, _desktopComponent2.default)(_class = function (_Component) {
  _inherits(Title, _Component);

  function Title(props, context, updater) {
    _classCallCheck(this, Title);

    var parentTheme = props.parentTheme;
    var selected = props.selected;

    var properties = _objectWithoutProperties(props, ['parentTheme', 'selected']);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Title).call(this, properties, context, updater));

    _this.state = {
      selected: selected,
      parentTheme: parentTheme
    };
    return _this;
  }

  _createClass(Title, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.content.item.splitView.currentTitle = this.props.children;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var style = _props.style;
      var previousTitle = _props.previousTitle;
      var children = _props.children;

      var componentStyle = _extends({}, styles.title, style);
      var fadeSpanStyle = _extends({}, styles.title, style, styles.fadeSpanStyle);
      var spanStyle = void 0;

      if (this.state.parentTheme === 'dark') {
        componentStyle = _extends({}, componentStyle, styles.titleDark);
        fadeSpanStyle = _extends({}, fadeSpanStyle, styles.titleDark);
      }

      var fadeSpan = void 0;
      if (previousTitle && previousTitle !== children) {
        fadeSpan = _react2.default.createElement(
          'span',
          { style: fadeSpanStyle },
          previousTitle
        );
        spanStyle = styles.titleAnimation;
      }

      return _react2.default.createElement(
        'div',
        { style: componentStyle },
        fadeSpan,
        _react2.default.createElement(
          'span',
          { style: spanStyle },
          children
        )
      );
    }
  }, {
    key: 'content',
    get: function get() {
      return this.context.parent;
    }
  }]);

  return Title;
}(_react.Component)) || _class;

exports.default = Title;