'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _desktopComponent = require('../../../../desktop-component');

var _desktopComponent2 = _interopRequireDefault(_desktopComponent);

var _icon = require('./icon');

var _icon2 = _interopRequireDefault(_icon);

var _color = require('../../../../color');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  anchor: {
    display: 'flex',
    alignItems: 'center',
    height: '44px',

    ':hover': {
      backgroundColor: 'rgba(0, 0, 0, .1)'
    },
    ':active': {
      backgroundColor: 'rgba(0, 0, 0, .2)'
    }
  },

  anchorDark: {
    ':hover': {
      backgroundColor: 'rgba(255, 255, 255, .1)'
    },
    ':active': {
      backgroundColor: 'rgba(255, 255, 255, .2)'
    }
  },

  span: {
    display: 'flex',
    alignItems: 'center',
    color: '#000000',
    fontFamily: '"Segoe UI", Frutiger, "Frutiger Linotype", "Dejavu Sans", "Helvetica Neue", Arial, sans-serif',
    fontSize: '15px',
    letterSpacing: '0.4pt',
    padding: '0 16px',
    transition: 'transform .1s ease-in'
  },

  spanDark: {
    color: '#ffffff'
  },

  pushTransformHover: {
    transition: 'transform .1s ease-in'
  },

  pushTransformActive: {
    transform: 'scale(0.97)',
    transition: 'transform 0s ease-in'
  }
};

var Item = (0, _desktopComponent2.default)(_class = (_temp = _class2 = function (_Component) {
  _inherits(Item, _Component);

  function Item(props, context, updater) {
    _classCallCheck(this, Item);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Item).call(this, props, context, updater));

    _this.onClick = function () {
      _this.pane.selectItem(_this);
      _this.pane.splitView.selectItem(_this.props.children);

      if (_this.props.onClick) {
        _this.props.onClick();
      }
    };

    _this.state = {
      isOpen: _this.props.isOpen,
      selected: _this.props.children.props.selected
    };
    return _this;
  }

  _createClass(Item, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var style = _props.style;
      var onClick = _props.onClick;
      var isOpen = _props.isOpen;

      var props = _objectWithoutProperties(_props, ['children', 'style', 'onClick', 'isOpen']);

      var title = this.state.isOpen ? children.props.title : null;
      var ItemIcon = children.props.icon;
      var anchorStyle = _extends({}, styles.anchor, style);
      var spanStyle = _extends({}, styles.span, style);

      if (this.state.theme === 'dark') {
        spanStyle = _extends({}, spanStyle, styles.spanDark);
      }

      if (this.state.selected) {
        anchorStyle = _extends({}, anchorStyle, {
          backgroundColor: (0, _color.transparentize)(this.state.color, .4),
          ':hover': _extends({}, anchorStyle[':hover'], {
            backgroundColor: (0, _color.transparentize)(this.state.color, .2)
          }),
          ':active': _extends({}, anchorStyle[':active'], {
            backgroundColor: (0, _color.transparentize)(this.state.color, .1)
          })
        });
      }

      if (this.context.push) {
        spanStyle[':hover'] = _extends({}, spanStyle[':hover'], styles.pushTransformHover);
        spanStyle[':active'] = _extends({}, spanStyle[':active'], styles.pushTransformActive);
      }

      return _react2.default.createElement(
        'a',
        _extends({
          ref: 'anchor',
          onClick: this.onClick,
          style: anchorStyle
        }, props),
        _react2.default.createElement(
          'span',
          {
            ref: 'span',
            style: spanStyle
          },
          ItemIcon ? _react2.default.createElement(_icon2.default, { hasMargin: this.state.isOpen, icon: ItemIcon }) : null,
          title
        )
      );
    }
  }, {
    key: 'pane',
    get: function get() {
      return this.context.parent;
    }
  }]);

  return Item;
}(_react.Component), _class2.propTypes = {
  onClick: _react.PropTypes.func
}, _class2.contextTypes = {
  push: _react.PropTypes.bool
}, _temp)) || _class;

exports.default = Item;