'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _desktopComponent = require('../../../desktop-component');

var _desktopComponent2 = _interopRequireDefault(_desktopComponent);

var _item = require('./item/item');

var _item2 = _interopRequireDefault(_item);

var _button = require('./button/button');

var _button2 = _interopRequireDefault(_button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  pane: {
    display: 'flex',
    position: 'relative',
    flexGrow: '0',
    flexShrink: '0',
    flexDirection: 'column',
    width: '200px',
    overflow: 'hidden'
  },

  padding: {
    height: '48px'
  },

  buttonStyle: {
    position: 'absolute',
    padding: '8px 10px',
    top: '7px',
    left: '4px',
    width: '20px',
    height: '20px'
  }
};

var Pane = (0, _desktopComponent2.default)(_class = (_temp = _class2 = function (_Component) {
  _inherits(Pane, _Component);

  function Pane(props, context, updater) {
    _classCallCheck(this, Pane);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Pane).call(this, props, context, updater));

    _this.toggleOpen = function () {
      _this.setState({ isOpen: !_this.state.isOpen });
      if (_this.refs) {
        for (var prop in _this.refs) {
          if (_this.refs.hasOwnProperty(prop)) {
            _this.refs[prop].setState({ isOpen: !_this.state.isOpen });
          }
        }
      }
      if (_this.props.onPaneToggle) {
        _this.props.onPaneToggle(!_this.state.isOpen);
      }
    };

    _this.state = {
      isOpen: context.isOpen !== false
    };
    return _this;
  }

  _createClass(Pane, [{
    key: 'filterChildren',
    value: function filterChildren(children) {
      var _this2 = this;

      return _react.Children.map(children, function (child, key) {
        var onClick = child.props.onClick;


        return _react2.default.createElement(
          _item2.default,
          { onClick: onClick, key: key, ref: key, identifierKey: key, isOpen: _this2.state.isOpen },
          child
        );
      });
    }
  }, {
    key: 'selectItem',
    value: function selectItem(item) {
      for (var prop in this.refs) {
        if (this.refs.hasOwnProperty(prop)) {
          if (this.refs[prop].props.identifierKey === item.props.identifierKey) {
            this.refs[prop].setState({ selected: true });
          } else {
            this.refs[prop].setState({ selected: false });
          }
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var style = _props.style;

      var props = _objectWithoutProperties(_props, ['children', 'style']);

      children = this.filterChildren(children);

      var componentStyle = _extends({}, styles.pane, style);
      if (this.context.openLength) {
        componentStyle.width = this.context.openLength + 'px';
      }

      if (!this.state.isOpen) {
        componentStyle.width = this.context.compactLength ? this.context.compactLength : '48px';
      }

      return _react2.default.createElement(
        'div',
        _extends({
          style: componentStyle
        }, props),
        _react2.default.createElement('div', { style: styles.padding }),
        _react2.default.createElement(_button2.default, { style: styles.buttonStyle, onClick: this.toggleOpen }),
        children
      );
    }
  }, {
    key: 'splitView',
    get: function get() {
      return this.context.parent;
    }
  }]);

  return Pane;
}(_react.Component), _class2.Item = _item2.default, _class2.propTypes = {
  onPaneToggle: _react.PropTypes.func
}, _class2.contextTypes = {
  id: _react.PropTypes.string,
  compactLength: _react.PropTypes.number,
  openLength: _react.PropTypes.number,
  isOpen: _react.PropTypes.bool
}, _temp)) || _class;

exports.default = Pane;