'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _desktopComponent = require('../../desktop-component');

var _desktopComponent2 = _interopRequireDefault(_desktopComponent);

var _pane = require('./pane/pane');

var _pane2 = _interopRequireDefault(_pane);

var _splitViewItem = require('./split-view-item');

var _splitViewItem2 = _interopRequireDefault(_splitViewItem);

var _content = require('./content/content');

var _content2 = _interopRequireDefault(_content);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  display: 'flex',
  flexWrap: 'nowrap',
  position: 'relative',
  flex: '1'
};

var SplitView = (0, _desktopComponent2.default)(_class = (_temp = _class2 = function (_Component) {
  _inherits(SplitView, _Component);

  function SplitView(props, context, updater) {
    _classCallCheck(this, SplitView);

    var id = props.id;

    var properties = _objectWithoutProperties(props, ['id']);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(SplitView).call(this, properties, context, updater));

    _this.id = id || 'splitview';
    _this.firstRender = true;
    return _this;
  }

  _createClass(SplitView, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        id: this.id,
        compactLength: this.props.compactLength,
        openLength: this.props.openLength,
        placement: this.props.placement,
        isOpen: this.props.isOpen,
        push: this.props.push
      };
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      for (var prop in this.refs) {
        if (this.refs.hasOwnProperty(prop)) {
          this.refs[prop].setState({ parentTheme: this.state.theme });
        }
      }
    }
  }, {
    key: 'getItemStorageKey',
    value: function getItemStorageKey(key) {
      return '.' + this.id + '.$/.' + key;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props;
      var children = _props.children;
      var style = _props.style;

      var props = _objectWithoutProperties(_props, ['children', 'style']);

      var hasSelectedItem = false;
      _react.Children.map(children, function (child) {
        if (child.props.selected) {
          hasSelectedItem = true;
        }
      });

      var content = _react.Children.map(children, function (child, key) {
        var props = { ref: key };
        if (!hasSelectedItem && key === 0 && _this2.firstRender) {
          _this2.selectedItem = key;
          props.selected = true;
        } else if (_this2.selectedItem === key) {
          props.selected = true;
        }
        return (0, _react.cloneElement)(child, props);
      });

      this.firstRender = false;

      return _react2.default.createElement(
        'div',
        _extends({
          style: _extends({}, styles, style)
        }, props),
        _react2.default.createElement(
          _pane2.default,
          { onPaneToggle: this.props.onPaneToggle },
          content
        ),
        content
      );
    }
  }, {
    key: 'currentTitle',
    set: function set(value) {
      this._currentTitle = value;
    },
    get: function get() {
      return this._currentTitle || '';
    }
  }]);

  return SplitView;
}(_react.Component), _class2.Pane = _pane2.default, _class2.Content = _content2.default, _class2.Item = _splitViewItem2.default, _class2.propTypes = {
  id: _react.PropTypes.string,
  compactLength: _react.PropTypes.number,
  openLength: _react.PropTypes.number,
  placement: _react.PropTypes.string,
  isOpen: _react.PropTypes.bool,
  push: _react.PropTypes.bool,
  onPaneToggle: _react.PropTypes.func
}, _class2.childContextTypes = {
  id: _react.PropTypes.string,
  compactLength: _react.PropTypes.number,
  openLength: _react.PropTypes.number,
  placement: _react.PropTypes.string,
  isOpen: _react.PropTypes.bool,
  push: _react.PropTypes.bool
}, _temp)) || _class;

exports.default = SplitView;