'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _controls = require('./controls/controls');

var _controls2 = _interopRequireDefault(_controls);

var _osx = require('./styles/osx.10.11');

var _osx2 = _interopRequireDefault(_osx);

var _desktopComponent = require('../../desktop-component');

var _desktopComponent2 = _interopRequireDefault(_desktopComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TitleBar = (_dec = (0, _desktopComponent2.default)(_desktopComponent.WindowFocus), _dec(_class = (_temp2 = _class2 = function (_Component) {
  _inherits(TitleBar, _Component);

  function TitleBar() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    _classCallCheck(this, TitleBar);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(TitleBar)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.resize = function () {
      var barRect = _this.refs.element.getBoundingClientRect();
      _this.refs.title.style.overflow = 'visible';
      _this.refs.title.style.paddingRight = 0;
      _this.refs.title.style.flexGrow = 0;
      var titleRect = _this.refs.title.getBoundingClientRect();
      _this.refs.title.style.overflow = 'hidden';
      _this.refs.title.style.flexGrow = 1;

      var barWidth = barRect.width - 6;
      var contentWidth = titleRect.width + (_this.props.controls ? 60 : 0);

      var padding = barWidth - contentWidth;
      if (padding > 60) padding = 60;

      _this.refs.title.style.paddingRight = padding + 'px';
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TitleBar, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      window.addEventListener('resize', this.resize);
      this.resize();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.resize);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.resize();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var controls = _props.controls;
      var title = _props.title;

      var props = _objectWithoutProperties(_props, ['children', 'controls', 'title']);

      var componentStyle = _extends({}, _osx2.default.titleBar);
      if (children) {
        componentStyle = _extends({}, componentStyle, _osx2.default.toolbar);
      }

      var titleStyle = _osx2.default.title;

      if (!this.state.windowFocused) {
        componentStyle = _extends({}, componentStyle, _osx2.default.unfocusedTitleBar);
        titleStyle = _extends({}, titleStyle, _osx2.default.unfocusedTitle);
      }

      controls = !controls || _react2.default.createElement(_controls2.default, _extends({ ref: 'controls' }, this.props));
      title = !title || _react2.default.createElement(
        'div',
        { ref: 'title', style: titleStyle },
        this.props.title
      );

      return _react2.default.createElement(
        'div',
        _extends({
          ref: 'element',
          style: componentStyle
        }, props),
        controls,
        title,
        children
      );
    }
  }]);

  return TitleBar;
}(_react.Component), _class2.propTypes = {
  title: _react.PropTypes.string,
  controls: _react.PropTypes.bool,
  isFullscreen: _react.PropTypes.bool,
  onCloseClick: _react.PropTypes.func,
  onMinimizeClick: _react.PropTypes.func,
  onMaximizeClick: _react.PropTypes.func,
  onResizeClick: _react.PropTypes.func
}, _temp2)) || _class);
exports.default = TitleBar;