'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _desktopComponent = require('../../desktop-component');

var _desktopComponent2 = _interopRequireDefault(_desktopComponent);

var _controls = require('./controls/controls');

var _controls2 = _interopRequireDefault(_controls);

var _windows = require('./styles/windows.10');

var _windows2 = _interopRequireDefault(_windows);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TitleBar = (_dec = (0, _desktopComponent2.default)(_desktopComponent.WindowFocus, _desktopComponent.Background), _dec(_class = (_temp = _class2 = function (_Component) {
  _inherits(TitleBar, _Component);

  function TitleBar() {
    _classCallCheck(this, TitleBar);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(TitleBar).apply(this, arguments));
  }

  _createClass(TitleBar, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        isMaximized: this.props.isMaximized
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var style = _props.style;
      var controls = _props.controls;
      var title = _props.title;

      var props = _objectWithoutProperties(_props, ['children', 'style', 'controls', 'title']);

      var componentStyle = _extends({}, _windows2.default.titleBar, style);
      var titleStyle = _windows2.default.title;

      if (!this.state.windowFocused && this.state.theme !== 'dark') {
        titleStyle = _extends({}, titleStyle, _windows2.default.unfocusedTitle);
      }

      if (this.state.theme === 'dark') {
        titleStyle = _extends({}, titleStyle, _windows2.default.titleDark);
      }

      componentStyle = _extends({}, componentStyle, {
        visibility: this.state.visible ? 'visible' : 'hidden',
        display: this.state.display ? 'flex' : 'none'
      });

      if (this.state.theme === 'dark') {
        componentStyle = _extends({}, componentStyle, _windows2.default.titleBarDark);
      }

      var controlsComponent = !controls || _react2.default.createElement(_controls2.default, this.props);
      var titleComponent = !title || _react2.default.createElement(
        'div',
        { style: titleStyle },
        this.props.title
      );

      if (this.props.background) delete componentStyle.backgroundColor;

      return _react2.default.createElement(
        'div',
        _extends({
          ref: 'element',
          style: componentStyle
        }, props),
        titleComponent,
        controlsComponent,
        children
      );
    }
  }]);

  return TitleBar;
}(_react.Component), _class2.propTypes = {
  title: _react.PropTypes.string,
  controls: _react.PropTypes.bool,
  isMaximized: _react.PropTypes.bool,
  onCloseClick: _react.PropTypes.func,
  onMinimizeClick: _react.PropTypes.func,
  onMaximizeClick: _react.PropTypes.func,
  onRestoreDownClick: _react.PropTypes.func
}, _class2.childContextTypes = {
  isMaximized: _react.PropTypes.bool
}, _temp)) || _class);
exports.default = TitleBar;