'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _desktopComponent = require('../../desktop-component');

var _desktopComponent2 = _interopRequireDefault(_desktopComponent);

var _titleBar = require('../../title-bar/title-bar.windows/title-bar');

var _titleBar2 = _interopRequireDefault(_titleBar);

var _view = require('../../view/view');

var _view2 = _interopRequireDefault(_view);

var _windows = require('./styles/windows.10');

var _windows2 = _interopRequireDefault(_windows);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Window = (_dec = (0, _desktopComponent2.default)(_desktopComponent.WindowFocus, (0, _desktopComponent.Dimension)('100vw', '100vh'), _desktopComponent.Alignment, _desktopComponent.Padding, _desktopComponent.Hidden), _dec(_class = (_temp = _class2 = function (_Component) {
  _inherits(Window, _Component);

  function Window() {
    _classCallCheck(this, Window);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Window).apply(this, arguments));
  }

  _createClass(Window, [{
    key: 'filterChildren',
    value: function filterChildren() {
      var titleBar = '';
      var otherChildren = [];
      _react.Children.map(this.props.children, function (element) {
        if (element.type === _titleBar2.default) {
          titleBar = element;
        } else {
          otherChildren = [].concat(_toConsumableArray(otherChildren), [element]);
        }
      });

      return [titleBar].concat(_toConsumableArray(otherChildren));
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var style = _props.style;
      var chrome = _props.chrome;

      var props = _objectWithoutProperties(_props, ['style', 'chrome']);

      var componentStyle = _extends({}, _windows2.default.window, style);
      if (chrome) {
        componentStyle = _extends({}, componentStyle, _windows2.default.chrome, {
          borderColor: this.state.color
        });

        if (!this.state.windowFocused) {
          componentStyle = _extends({}, componentStyle, _windows2.default.unfocused);
        }
      }

      if (this.state.theme === 'dark') {
        componentStyle = _extends({}, componentStyle, _windows2.default.windowDark);
      }

      if (this.state.background) {
        componentStyle = _extends({}, componentStyle, { backgroundColor: this.state.background });
      }

      var _filterChildren = this.filterChildren();

      var _filterChildren2 = _toArray(_filterChildren);

      var titleBar = _filterChildren2[0];

      var children = _filterChildren2.slice(1);

      var content = _react2.default.createElement(
        _view2.default,
        { ref: 'content', style: _windows2.default.content },
        children
      );

      return _react2.default.createElement(
        'div',
        _extends({
          style: componentStyle
        }, props),
        titleBar,
        content
      );
    }
  }]);

  return Window;
}(_react.Component), _class2.propTypes = {
  chrome: _react.PropTypes.bool
}, _class2.styleRefs = {
  padding: 'content'
}, _temp)) || _class);
exports.default = Window;